//$ = jQuery.noConflict(true);

self.port.on("noresults", function (results) {
    $('#results').empty();
    $('.tool').hide();
    $('#results').show();
    var $strong = $("<span/>", {class: "strong", text:results});
    var $text = $("<span/>", {text:': sorry, no result'});
    $('#results').append($("<div/>", {class: "form"})).append($strong).append($text);
});

self.port.on("results", function (results) {
    $('#results').empty();
    $('.tool').hide();
    $('#results').show();
    $.each(results, function(idx, result) {
        var text = descrFormByPos(result.form);
        var $div = $("<div>");
        var $mistake = $("<div>", {class: "mistake-mark maroon", text:'m?'});
        var $form_div = $("<div>", {class: "form"}); 
        var $form = $("<span>", {class: "descr"});
        var $strong = $("<b>", {text:result.form.form});
        var $text = $("<span>", {class: "plain", text: text});
        $form.append($strong);
        $form.append($text);
        $form_div.append($form); 
        $div.append($mistake);
        $div.append($form_div);
        $('#results').append($div);
        _.each(result.dicts, function(dict){
            showDict(dict);
        });
    });
});

function showDict(dict){
    var dictdescr = '';
    if (dict.pos == 'noun') 
        dictdescr = 'sggen: ' + dict.sggen + ', gend: ' + dict.gend + ', decl: ' +  dict.descr;
    else if (dict.impers) 
        dictdescr = 'impers';
    else if (dict.pos == 'verb') 
        dictdescr = 'inf: ' + dict.inf + ', perf: ' + dict.perf + ', supine: ' +  dict.supine;
    else if (dict.pos == 'adj') 
        dictdescr = 'raw flex: ' + dict.rawflex + ', decl: ' + dict.descr;
    var $dict_div = $("<div>", {class: "dict-descr", text:'dict: '});
    var $dict_dict = $('<b>').text(dict.dict);
    var dict_descr = ' ' + [dict.pos, dictdescr].join(', ');
    var $dict_descr = $("<span>", {text:dict_descr});
    $dict_div.append($dict_dict).append($dict_descr);
    $('.form:last').append($dict_div);
    if (dict.ref) {
        var $dict_div_ref = $("<div>", {class: "dict-descr", text:'ref: '});
        var $dict_ref = $("<span>", {class: "example maroon", text:dict.ref});
        $dict_div_ref.append($dict_ref);
        $('.dict-descr:last').append($dict_div_ref);
    }
    _.each([dict.en, dict.ru], function(trn, idx){
        var lang = (idx==0) ? 'en: ' : 'ru: ';
        _.each(trn, function(line, i){
            line = ' ' + line;
            var $trn_line = '';
            var threedot = (trn.length>1) ? '...' : '';
            var $trn_div = $("<div>", {class: "trn maroon"});
            var $trn_hidden = $("<div>", {class: "trn hidden"});
            var $trn_lang = $('<b>').text(lang);
            if (i == 0) {
                $trn_line = $("<span>", {text:(line+threedot)});
                $trn_div.append($trn_lang);
                $trn_div.append($trn_line);
                $('.dict-descr:last').append($trn_div);
                $('.dict-descr:last').append($trn_hidden);
            } else {
                $trn_line = $("<span>", {text:line});
                $('.trn:last').append($trn_line);
            }
        });
    });
} 

function descrFormByPos(form){
    var descr = '== no descr == pos: ' + form.pos;
    if (form.pos == 'verb') {
        if (form.morphs){
            var morphdescr = '';
            var morphs = form.morphs;
            morphs = [].concat(morphs);
            _.each(morphs, function(hash){
                morphdescr += [hash.number, hash.person].join(".");
            });
            descr = _.compact([form.pos, form.descr, morphdescr]).join(", ");
        }
        else if (form.impers)
            descr = 'verb impers';
    } else if (form.pos == 'inf') {
        descr = _.compact([form.pos, form.descr]).join(", ");
    } else if (_.include(['noun', 'adj', 'part', 'pron'], form.pos)){
        var descrs = [];
        var gends = _.groupBy(form.morphs, 'gend');
        _.each(gends, function(arr, gend){
            var morphs = [];
            _.each(arr, function(hash){
                morphs.push([hash.number, hash.kase].join("."));
            });
            descrs.push(gend + ', ' + morphs);
        });
        descr = _.compact([form.pos, form.grad, form.descr, descrs.join(", ")]).join(", ");
    } else if (_.include(['adv', 'conj'], form.pos)){
        descr = _.compact([form.pos, form.grad]).join(", ");
    } else if (_.include(['prep'], form.pos)){
        descr = _.compact([form.pos, form.prep.join(", ")]).join(", ");
    }
    return ' ' + descr;
}

showMorphTool();
function showMorphTool(){
    $('#morph-tool-title').click(function(){
        $('.tool').hide();
        $('#morph-tool').toggle();
        $('#query').focus();
        $('#morphquery').bind("submit", function(e) {
            var text = $('#query').val(); //.replace(/(\r\n|\n|\r)/gm,"");
            if (text != '') self.port.emit("query-entered", text);
            $('#query').val('');
            e.stopPropagation();
            e.preventDefault();
        });
    });
    $('#morph-disclaimer-title').click(function(){
        $('.tool').hide();
        $('#morph-disclaimer').toggle();
    });
    $('#morph-about-title').click(function(){
        $('.tool').hide();
        $('#morph-about').toggle();
    });
    $('.mistake-mark').live("click", function(e){
        $('.tool').hide();
        $('#mistake').toggle();
        var results = $(this).siblings().find('span.descr').text();
        $('#note').text('Hi, \n ' + results + ' - \n is a mistake, because: '); 
        $('#name').focus();
    });
}

$('.trn').live("click", function(){
    $(this).next().toggle();
});

$('#x').click(function(e){
    e.stopPropagation();
    e.preventDefault();
    self.port.emit("close");
});

$('img').click(function(){
    self.port.emit("home");
});
$('#home_morpheus').click(function(){
    self.port.emit("home_morpheus");
});

$('.example').live('click', function(){
    var text = $(this).text();
    if (text != '') self.port.emit("query-entered", text);
});

$('#mistake-form').submit(function(e){
    var name = $('#name').val();
    var email = $('#email').val();
    var note = $('#note').val().replace(/\n/g, '');
    if (note == '') return false;
    $('.tool').hide();
    $('#send-ok').toggle();
    e.stopPropagation();
    e.preventDefault();
    self.port.emit("email-send", {name:name, email:email, note:note});
    //return false;
});


function inspect(object){
    var result = '';
    for (var key in object){
	result += key + ': ' + object[key] + '\n';
    }
    return result;
}

