// if (typeof Morpheus == "undefined") {
//   var Morpheus = {};
// };

//var widgets = require("widget");
var tabs = require("tabs");
var selection = require("selection");
var Request = require("request").Request;
var data = require("self").data;
var _ = require("./underscore.js")
var lang = 'latin';

exports.main = function(){

    var pageMod = require("page-mod").PageMod({
        include: ['*'],
        contentScriptWhen: 'ready',
        contentScriptFile: [data.url("jquery-1.8.3.js"), data.url('pagemod.js')],
        onAttach: function(worker) {
            worker.port.on('selected', function(text){ 
                panel.show();
                getResults(text);
            });
            // worker.on('detach', function () {
            //     detachWorker(this, workers);
            // });
        }
    });

    function getLang(word){
        greeks = "ὄὄῤῥὝὙέὲἔἒἕἓἐἑὖὗῦΰῦύὺὔὒὓὓὐὑἶἷῖΐϊίὶἴἲἵἳἰἱὄόὸὄὅὂὃὀὁᾆᾀᾇᾴᾶἆἇᾳᾷάὰἄἂἂἃἀἁᾠᾡῴῷῷὦὧῶῷῳώὼὤὢὢὣὠὡᾗᾐᾐῇῄἦἧῆῇῃήὴἤἥἢἣἠἠθωερτψυιοπασδφγηκλζχξωβνμ";
        if (_.contains(greeks.split(''), word.split('')[1]))
            lang = 'greek';
        return lang;
    }

    function getResults(par) {
        if (selection.text) par = selection.text;
        if (par){
            var forms = '';
            var words = par.trim().replace(/[\.,;:!\?\"]/g, '').split(' '); 
            var word = words[0];
            var lang = getLang(word);
            if (lang == 'latin') {                
                _.each(words, function(word){
                    if (word != word.toLowerCase()) {
                        words.push(word.toLowerCase());
                    }
                    if (word.match(/que$/)) {
                        var good_ques = ["itaque", "namque", "neque", "quandoque", "que", "quoque"] + ["adaeque", "adusque", "aeque", "alterutrimque", "antique", "denique", "hucusque", "inique", "interutrasque", "itaque", "longinque", "oblique", "peraeque", "plerumque", "propinque", "quacumque", "quandoque", "quandoque", "quinque", "quocumque", "quomodocumque", "quotcumque", "ubicumque", "ubique", "undecumque", "undique", "usque", "usquequaque", "utcumque", "utique", "utrimque", "utroque", "utrubique"] + ["plerumque"]; // conj, adv, noun
                        _.contains(good_ques, word) ? '' : words.push(word.replace(/que$/,''));
                    }
                });
            }  
            words = _.uniq(words);
            var keys = {"keys": words};
            url = 'http://diglossa.ru:5984/' + lang + '-forms/_design/' + lang + '-forms/_list/sentence/by_all_forms?include_docs=true';
            var formsRequestOptions = {
                content: JSON.stringify(keys),
                url: url,
                onComplete: function (response) {
                    forms = response.json['rows'];
                    //forms = _.uniq(_.map(forms, function(form){return _.omit(form, ['type', '_id', '_rev'])}));  // alas, uniq
                    if (forms == ''){  
                        panel.port.emit('noresults', word);
                        return false;
                    }
                    var dicts = [];
                    _.each(forms, function(doc){
                        dicts.push(doc.dict);
                    });
                    dicts = _.uniq(dicts);
                    dkeys = {'keys': dicts};
                    getDicts(forms, dkeys);
                }
            };
            Request(formsRequestOptions).post();
        }
    }

    function getDicts(forms, dkeys){
        var dictsRequestOptions = {
            content: JSON.stringify(dkeys),
            url: 'http://diglossa.ru:5984/' + lang + '/_design/' + lang + '/_view/by_dict?include_docs=true',
            contentType:'application/json; charset=UTF-8',
            onComplete: function (response) {
                var rows = response.json['rows'];
                var dicts = _.pluck(rows, 'doc');
                var results = [];
                _.each(forms, function(form){
                    var result = {form:form, dicts:[]};
                    _.each(dicts, function(dict){
                        if (form.dict == dict.dict && form.pos == dict.pos) { 
                            //result['dicts'].push(dict);
                            pushUniq(result['dicts'], dict)
                        } else if (form.pos == 'part' &&  dict.pos == 'verb'){
                            pushUniq(result['dicts'], dict)
                        } else if (form.pos == 'inf' &&  dict.pos == 'verb'){
                            pushUniq(result['dicts'], dict)
                        }
                    }); 
                    results.push(result);
                }); 
                panel.port.emit('results', results);
            }
        };
        Request(dictsRequestOptions).post();
    }

    function pushUniq(arr, obj){
        var uniq = true;
        _.each(arr, function(item){
            if (_.isEqual(item, obj))
                uniq = false;
        });
        if (uniq)
            arr.push(obj);
    }

    var panel = require('panel').Panel({
        width: 500,
        height: 300,
        contentURL: data.url('morpheus.html'),
        contentScriptFile:
        [data.url('jquery-1.8.3.js'), data.url('show-morph.js'), data.url('../lib/underscore.js')]
    });

    panel.port.on('query-entered', function(text){
        getResults(text);
    });
    panel.port.on('close', function(){panel.hide()});
    panel.port.on('home', function(){tabs.open({
        url: 'http://diglossa.org',
        inBackground: true
    })});
    panel.port.on('home_morpheus', function(){tabs.open({
        url: 'http://diglossa.org/morpheus',
        inBackground: true
    })});
    panel.port.on('email-send', function(hash) {
        params = 'name='+hash.name+'&email='+hash.email+'&note='+hash.note;
        var sendMail = Request({
            url: 'http://diglossa.ru:8124/?'+JSON.stringify(params),
            onComplete: function (response) {
                var json = response.json;
            }
        });
        sendMail.get();
    });

}

function inspect(object){
    var result = '';
    for (var key in object){
	result += key + ': ' + object[key] + '\n';
    }
    return result;
}

